﻿namespace NesterovskyBros.Xsl
{
  using System;
  using System.Collections.Generic;
  using System.Linq;
  using System.Text;
  using System.IO;
  using System.Xml;
  using System.Xml.XPath;

  using NesterovskyBros.Xml;

  /// <summary>
  /// Defines a base class that implements XSLT extensions fucntions.
  /// </summary>
  public class XsltFunctions
  {
    /// <summary>
    /// Default constructor.
    /// </summary>
    public XsltFunctions()
    {
    }

    /// <summary>
    /// Creates a XsltFunctions instance and initializes it with
    /// a stream factory.
    /// </summary>
    /// <param name="factory">The stream factory.</param>
    public XsltFunctions(Func<string, Stream> factory)
    {
      this.factory = factory;
    }

    /// <summary>
    /// Creates an XPathNavigator instance by the specified name.
    /// </summary>
    /// <param name="name">a unique name for a data set.</param>
    /// <returns>an XPathNavigator instance.</returns>
    public XPathNavigator GetData(string name)
    {
      var navigator =
        new ForwardXPathNavigator(XmlReader.Create(factory(name)));

      return navigator;
    }

    /// <summary>
    /// Defines a stream factory.
    /// </summary>
    private Func<string, Stream> factory;
  }
}
