﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:msxsl="urn:schemas-microsoft-com:xslt"
  xmlns:d="http://www.nesterovsky-bros.com"
  exclude-result-prefixes="msxsl d">

  <xsl:output method="html" indent="yes"/>

  <!-- Root template processed in the streaming mode. -->
  <xsl:template match="/d:people">
    <html>
      <head>
        <title>List of persons</title>
        <style type="text/css">
           .even
           {
           }
           
           .odd
           {
             background: #d0d0d0;
           }
        </style>
      </head>
      <body>
        <table border="1">
          <tr>
            <th>ID</th>
            <th>First name</th>
            <th>Last name</th>
            <th>City</th>
            <th>Title</th>
            <th>Age</th>
            <th>Sex</th>
          </tr>
            
          <xsl:for-each select="d:person">
            <!-- Get element snapshot. -->
            <xsl:variable name="person">
              <xsl:copy-of select="."/>
            </xsl:variable>
             
            <xsl:variable name="position" select="position()"/>

            <xsl:apply-templates mode="snapshot" select="msxsl:node-set($person)/d:person">
              <xsl:with-param name="position" select="$position"/>            
            </xsl:apply-templates>
          </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>
  
  <xsl:template mode="snapshot" match="d:person">
    <xsl:param name="position"/>
      
    <tr>
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="$position mod 2 = 1">
            <xsl:text>odd</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>even</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      
      <td>
        <xsl:value-of select="d:Id"/>  
      </td>
      <td>
        <xsl:value-of select="d:FirstName"/>  
      </td>
      <td>
        <xsl:value-of select="d:LastName"/>  
      </td>
      <td>
        <xsl:value-of select="d:City"/>  
      </td>
      <td>
        <xsl:value-of select="d:Title"/>  
      </td>
      <td>
        <xsl:value-of select="d:Age"/>  
      </td>
      <td>
        <xsl:value-of select="d:Sex"/>
      </td>
    </tr>
  </xsl:template>

</xsl:stylesheet>
